Whamcloud - gitweb
LU-3131 tests: fix sanity 56u/102k for single OST.
[fs/lustre-release.git] / lustre / tests / sanity.sh
index e9753ca..2282370 100644 (file)
@@ -9,7 +9,7 @@ set -e
 
 ONLY=${ONLY:-"$*"}
 # bug number for skipped test: 13297 2108 9789 3637 9789 3561 12622 5188
-ALWAYS_EXCEPT="                27u   42a  42b  42c  42d  45   51d   68b   $SANITY_EXCEPT"
+ALWAYS_EXCEPT="                42a  42b  42c  42d  45   51d   68b   $SANITY_EXCEPT"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
 # with LOD/OSP landing
@@ -58,11 +58,11 @@ init_test_env $@
 . ${CONFIG:=$LUSTRE/tests/cfg/${NAME}.sh}
 init_logging
 
-[ "$SLOW" = "no" ] && EXCEPT_SLOW="24o 24v 27m 36f 36g 36h 51b 60c 63 64b 68 71 73 77f 78 101a 115 120g 124b"
+[ "$SLOW" = "no" ] && EXCEPT_SLOW="24o 27m 64b 68 71 77f 78 115 124b"
 
 [ $(facet_fstype $SINGLEMDS) = "zfs" ] &&
-# bug number for skipped test:        LU-2834 LU-1593 LU-2610 LU-2833 LU-1957 LU-2805
-       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 18      34h     40      48a     180     184c"
+# bug number for skipped test:        LU-1593 LU-2610 LU-2833 LU-1957 LU-2805
+       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 34h     40      48a     180     184c"
 
 FAIL_ON_ERROR=false
 
@@ -89,6 +89,13 @@ check_kernel_version() {
        return 1
 }
 
+check_swap_layouts_support()
+{
+       $LCTL get_param -n llite.*.sbi_flags | grep -q layout ||
+               { skip "Does not support layout lock."; return 0; }
+       return 1
+}
+
 if [ "$ONLY" == "cleanup" ]; then
        sh llmountcleanup.sh
        exit 0
@@ -468,9 +475,18 @@ str_repeat() {
 
 # Long symlinks and LU-2241
 test_17g() {
-        test_mkdir -p $DIR/$tdir
+       test_mkdir -p $DIR/$tdir
        local TESTS="59 60 61 4094 4095"
 
+       # Fix for inode size boundary in 2.1.4
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.1.4) ] &&
+               TESTS="4094 4095"
+
+       # Patch not applied to 2.2 or 2.3 branches
+       [ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.2.0) ] &&
+       [ $(lustre_version_code $SINGLEMDS) -le $(version_code 2.3.55) ] &&
+               TESTS="4094 4095"
+
        for i in $TESTS; do
                local SYMNAME=$(str_repeat 'x' $i)
                ln -s $SYMNAME $DIR/$tdir/f$i || error "failed $i-char symlink"
@@ -519,12 +535,12 @@ test_17k() { #bug 22301
         rsync --help | grep -q xattr ||
                 skip_env "$(rsync --version| head -1) does not support xattrs"
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-        test_mkdir -p $DIR/$tdir
+       test_mkdir -p $DIR/$tdir
        test_mkdir -p $DIR/$tdir.new
-        touch $DIR/$tdir/$tfile
-        ln -s $DIR/$tdir/$tfile $DIR/$tdir/$tfile.lnk
-        rsync -av -X $DIR/$tdir/ $DIR/$tdir.new ||
-                error "rsync failed with xattrs enabled"
+       touch $DIR/$tdir/$tfile
+       ln -s $DIR/$tdir/$tfile $DIR/$tdir/$tfile.lnk
+       rsync -av -X $DIR/$tdir/ $DIR/$tdir.new ||
+               error "rsync failed with xattrs enabled"
 }
 run_test 17k "symlinks: rsync with xattrs enabled ========================="
 
@@ -662,8 +678,8 @@ test_17n() {
 run_test 17n "run e2fsck against master/slave MDT which contains remote dir"
 
 test_18() {
-       touch $DIR/f
-       ls $DIR || error
+       touch $DIR/f || error "Failed to touch $DIR/f: $?"
+       ls $DIR || error "Failed to ls $DIR: $?"
 }
 run_test 18 "touch .../f ; ls ... =============================="
 
@@ -1103,6 +1119,11 @@ test_24z() {
        mrename $remote_src $remote_tgt &&
                error "rename remote dirs should not work!"
 
+       # If target dir does not exists, it should succeed
+       rm -rf $remote_tgt
+       mrename $remote_src $remote_tgt ||
+               error "rename remote dirs(tgt dir does not exists) failed!"
+
        rm -rf $DIR/$tdir || error "Can not delete directories"
 }
 run_test 24z "rename one remote dir to another remote dir should fail"
@@ -1478,21 +1499,24 @@ test_27t() { # bug 10864
 run_test 27t "check that utils parse path correctly"
 
 test_27u() { # bug 4900
-        [ "$OSTCOUNT" -lt "2" ] && skip_env "too few OSTs" && return
-        remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       [ "$OSTCOUNT" -lt "2" ] && skip_env "too few OSTs" && return
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       local index
+       local list=$(comma_list $(mdts_nodes))
 
 #define OBD_FAIL_MDS_OSC_PRECREATE      0x139
-        do_facet $SINGLEMDS lctl set_param fail_loc=0x139
-        test_mkdir -p $DIR/$tdir
-        createmany -o $DIR/$tdir/t- 1000
-        do_facet $SINGLEMDS lctl set_param fail_loc=0
+       do_nodes $list $LCTL set_param fail_loc=0x139
+       test_mkdir -p $DIR/$tdir
+       rm -rf $DIR/$tdir/*
+       createmany -o $DIR/$tdir/t- 1000
+       do_nodes $list $LCTL set_param fail_loc=0
 
-        TLOG=$DIR/$tfile.getstripe
-        $GETSTRIPE $DIR/$tdir > $TLOG
-        OBJS=`awk -vobj=0 '($1 == 0) { obj += 1 } END { print obj;}' $TLOG`
-        unlinkmany $DIR/$tdir/t- 1000
-        [ $OBJS -gt 0 ] && \
-                error "$OBJS objects created on OST-0.  See $TLOG" || pass
+       TLOG=$DIR/$tfile.getstripe
+       $GETSTRIPE $DIR/$tdir > $TLOG
+       OBJS=`awk -vobj=0 '($1 == 0) { obj += 1 } END { print obj;}' $TLOG`
+       unlinkmany $DIR/$tdir/t- 1000
+       [ $OBJS -gt 0 ] && \
+               error "$OBJS objects created on OST-0.  See $TLOG" || pass
 }
 run_test 27u "skip object creation on OSC w/o objects =========="
 
@@ -1638,6 +1662,19 @@ test_27y() {
                        do_facet $SINGLEMDS lctl --device %$OSC activate
                fi
        done
+
+       # all osp devices get activated, hence -1 stripe count restored
+       local stripecnt=0
+
+       # sleep 2*lod_qos_maxage seconds waiting for lod qos to notice osp
+       # devices get activated.
+       sleep_maxage
+       $SETSTRIPE -c -1 $DIR/$tfile
+       stripecnt=$($GETSTRIPE -c $DIR/$tfile)
+       rm -f $DIR/$tfile
+       [ $stripecnt -ne $OSTCOUNT ] &&
+               error "Of $OSTCOUNT OSTs, only $stripecnt is available"
+       return 0
 }
 run_test 27y "create files while OST0 is degraded and the rest inactive"
 
@@ -1682,29 +1719,38 @@ check_seq_oid()
                 log "want: stripe:$stripe_nr ost:$obdidx oid:$oid/$hex seq:$seq"
 
                 #don't unmount/remount the OSTs if we don't need to do that
-                #local dir=$(facet_mntpt ost$ost)
-                #stop ost$dev
-                #do_facet ost$dev mount -t $FSTYPE $dev $dir $OST_MOUNT_OPTS ||
-                #       { error "mounting $dev as $FSTYPE failed"; return 3; }
-                #local obj_file=$(do_facet ost$ost find $dir/O/$seq -name $oid)
-                #local ff=$(do_facet ost$ost $LL_DECODE_FILTER_FID $obj_file)
-               seq=$(echo $seq | sed -e "s/^0x//g")
-               if [ $seq == 0 ]; then
-                       oid_hex=$(echo $oid)
-               else
-                       oid_hex=$(echo $hex | sed -e "s/^0x//g")
+               # LU-2577 changes filter_fid to be smaller, so debugfs needs
+               # update too, until that use mount/ll_decode_filter_fid/mount
+               local dir=$(facet_mntpt ost$ost)
+               local opts=${OST_MOUNT_OPTS}
+
+               if !  do_facet ost$ost test -b ${dev}; then
+                       opts=$(csa_add "$opts" -o loop)
                fi
-                local obj_file="O/$seq/d$((oid %32))/$oid_hex"
-                local ff=$(do_facet ost$ost "$DEBUGFS -c -R 'stat $obj_file' \
-                           $dev 2>/dev/null" | grep "parent=")
+
+               stop ost$ost
+               do_facet ost$ost mount -t $(facet_fstype ost$ost) $opts $dev $dir ||
+                       { error "mounting $dev as $FSTYPE failed"; return 3; }
+               local obj_file=$(do_facet ost$ost find $dir/O/$seq -name $oid)
+               local ff=$(do_facet ost$ost $LL_DECODE_FILTER_FID $obj_file)
+               do_facet ost$ost umount -d $dir
+               start ost$ost $dev $OST_MOUNT_OPTS
+
+               # re-enable when debugfs will understand new filter_fid
+               #seq=$(echo $seq | sed -e "s/^0x//g")
+               #if [ $seq == 0 ]; then
+               #       oid_hex=$(echo $oid)
+               #else
+               #       oid_hex=$(echo $hex | sed -e "s/^0x//g")
+               #fi
+                #local obj_file="O/$seq/d$((oid %32))/$oid_hex"
+               #local ff=$(do_facet ost$ost "$DEBUGFS -c -R 'stat $obj_file' \
+                #           $dev 2>/dev/null" | grep "parent=")
 
                 [ -z "$ff" ] && error "$obj_file: no filter_fid info"
 
                 echo "$ff" | sed -e 's#.*objid=#got: objid=#'
 
-                #do_facet ost$ost umount -d $dir
-                #start ost$ost $dev $OST_MOUNT_OPTS
-
                 # /mnt/O/0/d23/23: objid=23 seq=0 parent=[0x200000400:0x1e:0x1]
                 # fid: objid=23 seq=0 parent=[0x200000400:0x1e:0x0] stripe=1
                 local ff_parent=$(echo $ff|sed -e 's/.*parent=.//')
@@ -1768,6 +1814,55 @@ test_27A() { # b=19102
 }
 run_test 27A "check filesystem-wide default LOV EA values"
 
+test_27B() { # LU-2523
+       test_mkdir -p $DIR/$tdir
+       rm -f $DIR/$tdir/f0 $DIR/$tdir/f1
+       touch $DIR/$tdir/f0
+       # open f1 with O_LOV_DELAY_CREATE
+       # rename f0 onto f1
+       # call setstripe ioctl on open file descriptor for f1
+       # close
+       multiop $DIR/$tdir/f1 oO_RDWR:O_CREAT:O_LOV_DELAY_CREATE:nB1c \
+               $DIR/$tdir/f0
+
+       rm -f $DIR/$tdir/f1
+       # open f1 with O_LOV_DELAY_CREATE
+       # unlink f1
+       # call setstripe ioctl on open file descriptor for f1
+       # close
+       multiop $DIR/$tdir/f1 oO_RDWR:O_CREAT:O_LOV_DELAY_CREATE:uB1c
+
+       # Allow multiop to fail in imitation of NFS's busted semantics.
+       true
+}
+run_test 27B "call setstripe on open unlinked file/rename victim"
+
+test_27C() { #LU-2871
+       [ $OSTCOUNT -lt 2 ] && skip "needs >= 2 OSTs" && return
+
+       declare -a ost_idx
+       local index
+       local i
+       local j
+
+       test_mkdir -p $DIR/$tdir
+       cd $DIR/$tdir
+       for i in $(seq 0 $((OSTCOUNT - 1))); do
+               # set stripe across all OSTs starting from OST$i
+               $SETSTRIPE -i $i -c -1 $tfile$i
+               # get striping information
+               ost_idx=($($GETSTRIPE $tfile$i |
+                        tail -n $((OSTCOUNT + 1)) | awk '{print $1}'))
+               echo ${ost_idx[@]}
+               # check the layout
+               for j in $(seq 0 $((OSTCOUNT - 1))); do
+                       index=$(((i + j) % OSTCOUNT))
+                       [ ${ost_idx[$j]} -eq $index ] || error
+               done
+       done
+}
+run_test 27C "check full striping across all OSTs"
+
 # createtest also checks that device nodes are created and
 # then visible correctly (#2091)
 test_28() { # bug 2091
@@ -3683,7 +3778,8 @@ test_53() {
                ostnum=$(index_from_ostuuid ${ostname}_UUID)
                node=$(facet_active_host ost$((ostnum+1)))
                param="obdfilter.$ostname.last_id"
-               ost_last=$(do_node $node lctl get_param -n $param | head -n 1)
+               ost_last=$(do_node $node lctl get_param -n $param | head -n 1 |
+                          awk -F':' '{print $2}')
                 echo "$ostname.last_id=$ost_last ; MDS.last_id=$mds_last"
                 if [ $ost_last != $mds_last ]; then
                     error "$ostname.last_id=$ost_last ; MDS.last_id=$mds_last"
@@ -4206,11 +4302,13 @@ test_56u() { # LU-611
        [ $NUMS -eq $EXPECTED ] ||
                error "\"$CMD\" wrong: found $NUMS, expected $EXPECTED"
 
-       EXPECTED=$(((NUMDIRS + 1) * NUMFILES + ONESTRIPE))
-       CMD="$LFIND -stripe-index 0,1 -type f $TDIR"
-       NUMS=$($CMD | wc -l)
-       [ $NUMS -eq $EXPECTED ] ||
-               error "\"$CMD\" wrong: found $NUMS, expected $EXPECTED"
+       if [ $OSTCOUNT -gt 1 ]; then
+               EXPECTED=$(((NUMDIRS + 1) * NUMFILES + ONESTRIPE))
+               CMD="$LFIND -stripe-index 0,1 -type f $TDIR"
+               NUMS=$($CMD | wc -l)
+               [ $NUMS -eq $EXPECTED ] ||
+                       error "\"$CMD\" wrong: found $NUMS, expected $EXPECTED"
+       fi
 }
 run_test 56u "check lfs find -stripe-index works"
 
@@ -4331,6 +4429,29 @@ test_56w() {
 }
 run_test 56w "check lfs_migrate -c stripe_count works"
 
+test_56x() {
+       check_swap_layouts_support && return 0
+       [ "$OSTCOUNT" -lt "2" ] &&
+               skip_env "need 2 OST, skipping test" && return
+
+       local dir0=$DIR/$tdir/$testnum
+       mkdir -p $dir0 || error "creating dir $dir0"
+
+       local ref1=/etc/passwd
+       local file1=$dir0/file1
+
+       $SETSTRIPE -c 2 $file1
+       cp $ref1 $file1
+       $LFS migrate -c 1 $file1 || error "migrate failed rc = $?"
+       stripe=$($GETSTRIPE -c $file1)
+       [[ $stripe == 1 ]] || error "stripe of $file1 is $stripe != 1"
+       cmp $file1 $ref1 || error "content mismatch $file1 differs from $ref1"
+
+       # clean up
+       rm -f $file1
+}
+run_test 56x "lfs migration support"
+
 test_57a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        # note test will not do anything if MDS is not local
@@ -6090,7 +6211,7 @@ test_102k() {
         local default_size=`$GETSTRIPE -S $test_kdir`
         local default_count=`$GETSTRIPE -c $test_kdir`
         local default_offset=`$GETSTRIPE -i $test_kdir`
-        $SETSTRIPE -S 65536 -i 1 -c $OSTCOUNT $test_kdir ||
+       $SETSTRIPE -S 65536 -i 0 -c $OSTCOUNT $test_kdir ||
                 error 'dir setstripe failed'
         setfattr -n trusted.lov $test_kdir
         local stripe_size=`$GETSTRIPE -S $test_kdir`
@@ -6880,6 +7001,15 @@ test_118l()
 }
 run_test 118l "fsync dir ========="
 
+test_118m() # LU-3066
+{
+       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       test_mkdir -p $DIR/$tdir
+       $MULTIOP $DIR/$tdir DY || error "fdatasync dir failed"
+       rm -rf $DIR/$tdir
+}
+run_test 118m "fdatasync dir ========="
+
 [ "$SLOW" = "no" ] && [ -n "$OLD_RESENDCOUNT" ] && set_resend_count $OLD_RESENDCOUNT
 
 test_119a() # bug 11737
@@ -8161,20 +8291,20 @@ get_rename_size() {
 
 test_133d() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-    remote_ost_nodsh && skip "remote OST with nodsh" && return
-    remote_mds_nodsh && skip "remote MDS with nodsh" && return
-    do_facet $SINGLEMDS $LCTL list_param mdt.*.rename_stats ||
-        { skip "MDS doesn't support rename stats"; return; }
+       remote_ost_nodsh && skip "remote OST with nodsh" && return
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       do_facet $SINGLEMDS $LCTL list_param mdt.*.rename_stats ||
+       { skip "MDS doesn't support rename stats"; return; }
 
-    local testdir1=$DIR/${tdir}/stats_testdir1
-    local testdir2=$DIR/${tdir}/stats_testdir2
+       local testdir1=$DIR/${tdir}/stats_testdir1
+       local testdir2=$DIR/${tdir}/stats_testdir2
 
-    do_facet $SINGLEMDS $LCTL set_param mdt.*.rename_stats=clear
+       do_facet $SINGLEMDS $LCTL set_param mdt.*.rename_stats=clear
 
-    test_mkdir -p ${testdir1} || error "mkdir failed"
-    test_mkdir -p ${testdir2} || error "mkdir failed"
+       mkdir -p ${testdir1} || error "mkdir failed"
+       mkdir -p ${testdir2} || error "mkdir failed"
 
-    createmany -o $testdir1/test 512 || error "createmany failed"
+       createmany -o $testdir1/test 512 || error "createmany failed"
 
        # check samedir rename size
        mv ${testdir1}/test0 ${testdir1}/test_0
@@ -8193,18 +8323,18 @@ test_133d() {
        echo "source rename dir size: ${testdir1_size}"
        echo "target rename dir size: ${testdir2_size}"
 
-    local cmd="do_facet $SINGLEMDS $LCTL get_param mdt.*.rename_stats"
-    eval $cmd || error "$cmd failed"
-    local samedir=$($cmd | grep 'same_dir')
-    local same_sample=$(get_rename_size $testdir1_size)
-    [ -z "$samedir" ] && error "samedir_rename_size count error"
-    [ "$same_sample" -eq 1 ] || error "samedir_rename_size error $same_sample"
-    echo "Check same dir rename stats success"
+       local cmd="do_facet $SINGLEMDS $LCTL get_param mdt.*.rename_stats"
+       eval $cmd || error "$cmd failed"
+       local samedir=$($cmd | grep 'same_dir')
+       local same_sample=$(get_rename_size $testdir1_size)
+       [ -z "$samedir" ] && error "samedir_rename_size count error"
+       [ "$same_sample" -eq 1 ] || error "samedir_rename_size error $same_sample"
+       echo "Check same dir rename stats success"
 
-    do_facet $SINGLEMDS $LCTL set_param mdt.*.rename_stats=clear
+       do_facet $SINGLEMDS $LCTL set_param mdt.*.rename_stats=clear
 
-    # check crossdir rename size
-    mv ${testdir1}/test_0 ${testdir2}/test_0
+       # check crossdir rename size
+       mv ${testdir1}/test_0 ${testdir2}/test_0
 
        testdir1_size=$(ls -l $DIR/${tdir} |
                awk '/stats_testdir1/ {print $5}')
@@ -8220,15 +8350,15 @@ test_133d() {
        echo "source rename dir size: ${testdir1_size}"
        echo "target rename dir size: ${testdir2_size}"
 
-    eval $cmd || error "$cmd failed"
-    local crossdir=$($cmd | grep 'crossdir')
-    local src_sample=$(get_rename_size $testdir1_size crossdir_src)
-    local tgt_sample=$(get_rename_size $testdir2_size crossdir_tgt)
-    [ -z "$crossdir" ] && error "crossdir_rename_size count error"
-    [ "$src_sample" -eq 1 ] || error "crossdir_rename_size error $src_sample"
-    [ "$tgt_sample" -eq 1 ] || error "crossdir_rename_size error $tgt_sample"
-    echo "Check cross dir rename stats success"
-    rm -rf $DIR/${tdir}
+       eval $cmd || error "$cmd failed"
+       local crossdir=$($cmd | grep 'crossdir')
+       local src_sample=$(get_rename_size $testdir1_size crossdir_src)
+       local tgt_sample=$(get_rename_size $testdir2_size crossdir_tgt)
+       [ -z "$crossdir" ] && error "crossdir_rename_size count error"
+       [ "$src_sample" -eq 1 ] || error "crossdir_rename_size error $src_sample"
+       [ "$tgt_sample" -eq 1 ] || error "crossdir_rename_size error $tgt_sample"
+       echo "Check cross dir rename stats success"
+       rm -rf $DIR/${tdir}
 }
 run_test 133d "Verifying rename_stats ========================================"
 
@@ -8381,7 +8511,8 @@ run_test 150 "truncate/append tests"
 
 function roc_hit() {
        local list=$(comma_list $(osts_nodes))
-
+       #debug temp debug for LU-2902: lets see what values we get back
+       echo $(get_osd_param $list '' stats) 1>&2
        echo $(get_osd_param $list '' stats |
               awk '/'cache_hit'/ {sum+=$2} END {print sum}')
 }
@@ -8419,15 +8550,29 @@ test_151() {
 
        set_osd_param $list '' writethrough_cache_enable 1
 
-        # pages should be in the case right after write
-        dd if=/dev/urandom of=$DIR/$tfile bs=4k count=$CPAGES || error "dd failed"
-        local BEFORE=`roc_hit`
-        cancel_lru_locks osc
-        cat $DIR/$tfile >/dev/null
-        local AFTER=`roc_hit`
-        if ! let "AFTER - BEFORE == CPAGES"; then
-                error "NOT IN CACHE: before: $BEFORE, after: $AFTER"
-        fi
+       # check write cache is enabled on all obdfilters
+       if get_osd_param $list '' writethrough_cache_enable | grep 0; then
+               echo "oss write cache is NOT enabled"
+               return 0
+       fi
+
+#define OBD_FAIL_OBD_NO_LRU  0x609
+       do_nodes $list $LCTL set_param fail_loc=0x609
+
+       # pages should be in the case right after write
+       dd if=/dev/urandom of=$DIR/$tfile bs=4k count=$CPAGES ||
+               error "dd failed"
+
+       local BEFORE=`roc_hit`
+       cancel_lru_locks osc
+       cat $DIR/$tfile >/dev/null
+       local AFTER=`roc_hit`
+
+       do_nodes $list $LCTL set_param fail_loc=0
+
+       if ! let "AFTER - BEFORE == CPAGES"; then
+               error "NOT IN CACHE: before: $BEFORE, after: $AFTER"
+       fi
 
         # the following read invalidates the cache
         cancel_lru_locks osc
@@ -8543,16 +8688,13 @@ dot_lustre_fid_permission_check() {
                error "touch $MOUNT/.lustre/fid/$tfile should fail."
 
        echo "setxattr to $MOUNT/.lustre/fid"
-       setfattr -n trusted.name1 -v value1 $MOUNT/.lustre/fid &&
-               error "setxattr should fail."
+       setfattr -n trusted.name1 -v value1 $MOUNT/.lustre/fid
 
        echo "listxattr for $MOUNT/.lustre/fid"
-       getfattr -d -m "^trusted" $MOUNT/.lustre/fid &&
-               error "listxattr should fail."
+       getfattr -d -m "^trusted" $MOUNT/.lustre/fid
 
        echo "delxattr from $MOUNT/.lustre/fid"
-       setfattr -x trusted.name1 $MOUNT/.lustre/fid &&
-               error "delxattr should fail."
+       setfattr -x trusted.name1 $MOUNT/.lustre/fid
 
        echo "touch invalid fid: $MOUNT/.lustre/fid/[0x200000400:0x2:0x3]"
        touch $MOUNT/.lustre/fid/[0x200000400:0x2:0x3] &&
@@ -8571,6 +8713,21 @@ dot_lustre_fid_permission_check() {
        mrename $MOUNT/.lustre $MOUNT/.lustre/fid/$fid/.lustre &&
                error "rename .lustre to itself should fail."
 
+       local old_obf_mode=$(stat --format="%a" $DIR/.lustre/fid)
+       local new_obf_mode=777
+
+       echo "change mode of $DIR/.lustre/fid to $new_obf_mode"
+       chmod $new_obf_mode $DIR/.lustre/fid ||
+               error "chmod $new_obf_mode $DIR/.lustre/fid failed"
+
+       local obf_mode=$(stat --format=%a $DIR/.lustre/fid)
+       [ $obf_mode -eq $new_obf_mode ] ||
+               error "stat $DIR/.lustre/fid returned wrong mode $obf_mode"
+
+       echo "restore mode of $DIR/.lustre/fid to $old_obf_mode"
+       chmod $old_obf_mode $DIR/.lustre/fid ||
+               error "chmod $old_obf_mode $DIR/.lustre/fid failed"
+
        $OPENFILE -f O_LOV_DELAY_CREATE:O_CREAT $test_dir/$tfile-2
        fid=$($LFS path2fid $test_dir/$tfile-2)
        echo "cp /etc/passwd $MOUNT/.lustre/fid/$fid"
@@ -8602,7 +8759,6 @@ test_154a() {
                error "dot lustre permission check $fid failed"
 
        rm -rf $MOUNT/.lustre && error ".lustre is not allowed to be unlinked"
-       chmod 777 $MOUNT/.lustre && error ".lustre is not allowed to be chmod"
 
        touch $MOUNT/.lustre/file &&
                error "creation is not allowed under .lustre"
@@ -9016,7 +9172,7 @@ test_160() {
 }
 run_test 160 "changelog sanity"
 
-test_161() {
+test_161a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
     test_mkdir -p $DIR/$tdir
     cp /etc/hosts $DIR/$tdir/$tfile
@@ -9026,11 +9182,11 @@ test_161() {
     ln $DIR/$tdir/$tfile $DIR/$tdir/foo2/zachary
     ln $DIR/$tdir/$tfile $DIR/$tdir/foo1/luna
     ln $DIR/$tdir/$tfile $DIR/$tdir/foo2/thor
-    local FID=$($LFS path2fid $DIR/$tdir/$tfile | tr -d '[')
-    if [ "$($LFS fid2path $DIR $FID | wc -l)" != "5" ]; then
-       $LFS fid2path $DIR $FID
-       err17935 "bad link ea"
-    fi
+       local FID=$($LFS path2fid $DIR/$tdir/$tfile | tr -d '[]')
+       if [ "$($LFS fid2path $DIR $FID | wc -l)" != "5" ]; then
+               $LFS fid2path $DIR $FID
+               err17935 "bad link ea"
+       fi
     # middle
     rm $DIR/$tdir/foo2/zachary
     # last
@@ -9056,7 +9212,59 @@ test_161() {
     unlinkmany $DIR/$tdir/foo2/$longname 1000 || \
        error "failed to unlink many hardlinks"
 }
-run_test 161 "link ea sanity"
+run_test 161a "link ea sanity"
+
+test_161b() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       [ $MDSCOUNT -lt 2 ] &&
+               skip "skipping remote directory test" && return
+       local MDTIDX=1
+       local remote_dir=$DIR/$tdir/remote_dir
+
+       mkdir -p $DIR/$tdir
+       $LFS mkdir -i $MDTIDX $remote_dir ||
+               error "create remote directory failed"
+
+       cp /etc/hosts $remote_dir/$tfile
+       mkdir -p $remote_dir/foo1
+       mkdir -p $remote_dir/foo2
+       ln $remote_dir/$tfile $remote_dir/foo1/sofia
+       ln $remote_dir/$tfile $remote_dir/foo2/zachary
+       ln $remote_dir/$tfile $remote_dir/foo1/luna
+       ln $remote_dir/$tfile $remote_dir/foo2/thor
+
+       local FID=$($LFS path2fid $remote_dir/$tfile | tr -d '[' |
+                    tr -d ']')
+       if [ "$($LFS fid2path $DIR $FID | wc -l)" != "5" ]; then
+               $LFS fid2path $DIR $FID
+               err17935 "bad link ea"
+       fi
+       # middle
+       rm $remote_dir/foo2/zachary
+       # last
+       rm $remote_dir/foo2/thor
+       # first
+       rm $remote_dir/$tfile
+       # rename
+       mv $remote_dir/foo1/sofia $remote_dir/foo2/maggie
+       local link_path=$($LFS fid2path $FSNAME --link 1 $FID)
+       if [ "$DIR/$link_path" != "$remote_dir/foo2/maggie" ]; then
+               $LFS fid2path $DIR $FID
+               err17935 "bad link rename"
+       fi
+       rm $remote_dir/foo2/maggie
+
+       # overflow the EA
+       local longname=filename_avg_len_is_thirty_two_
+       createmany -l$remote_dir/foo1/luna $remote_dir/foo2/$longname 1000 ||
+               error "failed to hardlink many files"
+       links=$($LFS fid2path $DIR $FID | wc -l)
+       echo -n "${links}/1000 links in link EA"
+       [ ${links} -gt 60 ] || err17935 "expected at least 60 links in link EA"
+       unlinkmany $remote_dir/foo2/$longname 1000 ||
+       error "failed to unlink many hardlinks"
+}
+run_test 161b "link ea sanity under remote directory"
 
 check_path() {
     local expected=$1
@@ -9380,43 +9588,6 @@ test_183() { # LU-2275
 }
 run_test 183 "No crash or request leak in case of strange dispositions ========"
 
-test_185() { # LU-2441
-       mkdir -p $DIR/$tdir || error "creating dir $DIR/$tdir"
-       touch $DIR/$tdir/spoo
-       local mtime1=$(stat -c "%Y" $DIR/$tdir)
-       local fid=$($MULTIOP $DIR/$tdir VFw4096c) ||
-               error "cannot create/write a volatile file"
-       $CHECKSTAT -t file $MOUNT/.lustre/fid/$fid 2>/dev/null &&
-               error "FID is still valid after close"
-
-       multiop_bg_pause $DIR/$tdir vVw4096_c
-       local multi_pid=$!
-
-       local OLD_IFS=$IFS
-       IFS=":"
-       local fidv=($fid)
-       IFS=$OLD_IFS
-       # assume that the next FID for this client is sequential, since stdout
-       # is unfortunately eaten by multiop_bg_pause
-       local n=$((${fidv[1]} + 1))
-       local next_fid="${fidv[0]}:$(printf "0x%x" $n):${fidv[2]}"
-       $CHECKSTAT -t file $MOUNT/.lustre/fid/$next_fid ||
-               error "FID is missing before close"
-       kill -USR1 $multi_pid
-       # 1 second delay, so if mtime change we will see it
-       sleep 1
-       local mtime2=$(stat -c "%Y" $DIR/$tdir)
-       [[ $mtime1 == $mtime2 ]] || error "mtime has changed"
-}
-run_test 185 "Volatile file support"
-
-check_swap_layouts_support()
-{
-       $LCTL get_param -n llite.*.sbi_flags | grep -q layout ||
-               { skip "Does not support layout lock."; return 0; }
-       return 1
-}
-
 # test suite 184 is for LU-2016, LU-2017
 test_184a() {
        check_swap_layouts_support && return 0
@@ -9496,7 +9667,8 @@ test_184c() {
        dd if=$ref1 of=$file1 bs=16k &
        local DD_PID=$!
 
-       sleep 0.$((RANDOM % 5 + 1))
+       # Make sure dd starts to copy file
+       while [ ! -f $file1 ]; do sleep 0.1; done
 
        $LFS swap_layouts $file1 $file2
        local rc=$?
@@ -9522,6 +9694,36 @@ test_184c() {
 }
 run_test 184c "Concurrent write and layout swap"
 
+test_185() { # LU-2441
+       mkdir -p $DIR/$tdir || error "creating dir $DIR/$tdir"
+       touch $DIR/$tdir/spoo
+       local mtime1=$(stat -c "%Y" $DIR/$tdir)
+       local fid=$($MULTIOP $DIR/$tdir VFw4096c) ||
+               error "cannot create/write a volatile file"
+       $CHECKSTAT -t file $MOUNT/.lustre/fid/$fid 2>/dev/null &&
+               error "FID is still valid after close"
+
+       multiop_bg_pause $DIR/$tdir vVw4096_c
+       local multi_pid=$!
+
+       local OLD_IFS=$IFS
+       IFS=":"
+       local fidv=($fid)
+       IFS=$OLD_IFS
+       # assume that the next FID for this client is sequential, since stdout
+       # is unfortunately eaten by multiop_bg_pause
+       local n=$((${fidv[1]} + 1))
+       local next_fid="${fidv[0]}:$(printf "0x%x" $n):${fidv[2]}"
+       $CHECKSTAT -t file $MOUNT/.lustre/fid/$next_fid ||
+               error "FID is missing before close"
+       kill -USR1 $multi_pid
+       # 1 second delay, so if mtime change we will see it
+       sleep 1
+       local mtime2=$(stat -c "%Y" $DIR/$tdir)
+       [[ $mtime1 == $mtime2 ]] || error "mtime has changed"
+}
+run_test 185 "Volatile file support"
+
 # OST pools tests
 check_file_in_pool()
 {
@@ -9980,6 +10182,13 @@ verify_jobstats() {
        fi
 }
 
+jobstats_set() {
+       trap 0
+       NEW_JOBENV=${1:-$OLD_JOBENV}
+       do_facet mgs $LCTL conf_param $FSNAME.sys.jobid_var=$NEW_JOBENV
+       wait_update $HOSTNAME "$LCTL get_param -n jobid_var" $NEW_JOBENV
+}
+
 test_205() { # Job stats
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        [ -z "$(lctl get_param -n mdc.*.connect_flags | grep jobstats)" ] &&
@@ -9988,9 +10197,8 @@ test_205() { # Job stats
        local cmd
        OLD_JOBENV=`$LCTL get_param -n jobid_var`
        if [ $OLD_JOBENV != $JOBENV ]; then
-               do_facet mgs $LCTL conf_param $FSNAME.sys.jobid_var=$JOBENV
-               wait_update $HOSTNAME "$LCTL get_param -n jobid_var" \
-                       $JOBENV || return 1
+               jobstats_set $JOBENV
+               trap jobstats_set EXIT
        fi
 
        # mkdir
@@ -10027,11 +10235,7 @@ test_205() { # Job stats
        # cleanup
        rm -f $DIR/jobstats_test_rename
 
-       if [ $OLD_JOBENV != $JOBENV ]; then
-               do_facet mgs $LCTL conf_param $FSNAME.sys.jobid_var=$OLD_JOBENV
-               wait_update $HOSTNAME "$LCTL get_param -n jobid_var" \
-                       $OLD_JOBENV || return 1
-       fi
+       [ $OLD_JOBENV != $JOBENV ] && jobstats_set $OLD_JOBENV
 }
 run_test 205 "Verify job stats"
 
@@ -10472,9 +10676,13 @@ run_test 224b "Don't panic on bulk IO failure"
 MDSSURVEY=${MDSSURVEY:-$(which mds-survey 2>/dev/null || true)}
 test_225a () {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-       if [ -z ${MDSSURVEY} ]; then
-              skip_env "mds-survey not found" && return
-       fi
+       if [ -z ${MDSSURVEY} ]; then
+             skip_env "mds-survey not found" && return
+       fi
+
+       [ $MDSCOUNT -ge 2 ] &&
+               skip "skipping now for more than one MDT" && return
+
        [ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.2.51) ] ||
             { skip "Need MDS version at least 2.2.51"; return; }
 
@@ -10497,16 +10705,19 @@ run_test 225a "Metadata survey sanity with zero-stripe"
 
 test_225b () {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-       if [ -z ${MDSSURVEY} ]; then
-              skip_env "mds-survey not found" && return
-       fi
-       [ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.2.51) ] ||
-            { skip "Need MDS version at least 2.2.51"; return; }
 
-       if [ $($LCTL dl | grep -c osc) -eq 0 ]; then
-              skip_env "Need to mount OST to test" && return
-       fi
+       if [ -z ${MDSSURVEY} ]; then
+             skip_env "mds-survey not found" && return
+       fi
+       [ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.2.51) ] ||
+           { skip "Need MDS version at least 2.2.51"; return; }
+
+       if [ $($LCTL dl | grep -c osc) -eq 0 ]; then
+             skip_env "Need to mount OST to test" && return
+       fi
 
+       [ $MDSCOUNT -ge 2 ] &&
+               skip "skipping now for more than one MDT" && return
        local mds=$(facet_host $SINGLEMDS)
        local target=$(do_nodes $mds 'lctl dl' | \
                       awk "{if (\$2 == \"UP\" && \$3 == \"mdt\") {print \$4}}")
@@ -10552,7 +10763,7 @@ mcreate_path2fid () {
        echo "pass with $path and $fid"
 }
 
-test_226 () {
+test_226a () {
        rm -rf $DIR/$tdir
        mkdir -p $DIR/$tdir
 
@@ -10565,7 +10776,29 @@ test_226 () {
        mcreate_path2fid 0120666 0 0 link "symbolic link"
        mcreate_path2fid 0140666 0 0 sock "socket"
 }
-run_test 226 "call path2fid and fid2path on files of all type"
+run_test 226a "call path2fid and fid2path on files of all type"
+
+test_226b () {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       rm -rf $DIR/$tdir
+       local MDTIDX=1
+
+       mkdir -p $DIR/$tdir
+       $LFS setdirstripe -i $MDTIDX $DIR/$tdir/remote_dir ||
+               error "create remote directory failed"
+       mcreate_path2fid 0010666 0 0 "remote_dir/fifo" "FIFO"
+       mcreate_path2fid 0020666 1 3 "remote_dir/null" \
+                               "character special file (null)"
+       mcreate_path2fid 0020666 1 255 "remote_dir/none" \
+                               "character special file (no device)"
+       mcreate_path2fid 0040666 0 0 "remote_dir/dir" "directory"
+       mcreate_path2fid 0060666 7 0 "remote_dir/loop0" \
+                               "block special file (loop)"
+       mcreate_path2fid 0100666 0 0 "remote_dir/file" "regular file"
+       mcreate_path2fid 0120666 0 0 "remote_dir/link" "symbolic link"
+       mcreate_path2fid 0140666 0 0 "remote_dir/sock" "socket"
+}
+run_test 226b "call path2fid and fid2path on files of all type under remote dir"
 
 # LU-1299 Executing or running ldd on a truncated executable does not
 # cause an out-of-memory condition.
@@ -10828,6 +11061,20 @@ test_231b() {
 }
 run_test 231b "must not assert on fully utilized OST request buffer"
 
+test_232() {
+       mkdir -p $DIR/$tdir
+       #define OBD_FAIL_LDLM_OST_LVB            0x31c
+       $LCTL set_param fail_loc=0x31c
+
+       # ignore dd failure
+       dd if=/dev/zero of=$DIR/$tdir/$tfile bs=1M count=1 || true
+
+       $LCTL set_param fail_loc=0
+       umount_client $MOUNT || error "umount failed"
+       mount_client $MOUNT || error "mount failed"
+}
+run_test 232 "failed lock should not block umount"
+
 #
 # tests that do cleanup/setup should be run at the end
 #